package com.wall.photography.wallpapers.acctivity

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.TextView.OnEditorActionListener
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.GridLayoutManager
import com.wall.photography.wallpapers.R
import com.wall.photography.wallpapers.connector.OnItemClick
import com.wall.photography.wallpapers.databinding.ActivitySearchBinding
import com.wall.photography.wallpapers.item.ItemList
import com.wall.photography.wallpapers.mybean.MyData
import com.wall.photography.wallpapers.tool.ComUtils
import com.wall.photography.wallpapers.tool.ItemHelper
import com.wall.photography.wallpapers.tool.ObectBoxManager
import com.wall.photography.wallpapers.topon.AdManager

class SearchActivity : AppCompatActivity() ,
    OnItemClick {
    private lateinit var adapterWallapper: ItemList
    private lateinit var binding:ActivitySearchBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivitySearchBinding.inflate(layoutInflater)
        setContentView(binding.root)
        AdManager.loadAllAd()
        ComUtils.initFull(this, false)
        initList()
        binding.imageviewBack.setOnClickListener {
            finish()
        }
    }


    private fun initList() {
        val height = ComUtils.dp2Px(180)
        adapterWallapper =
            ItemList(this, height, true)
        adapterWallapper.setInfoWallpaperListener(this)
        val recyclerItemHelper = ItemHelper(10, 10, 15)
        val gridLayoutManager = GridLayoutManager(this, 2)
        binding.resultRecycler.run {
            layoutManager = gridLayoutManager
            addItemDecoration(recyclerItemHelper)
            adapter = adapterWallapper
        }

        binding.et.setOnEditorActionListener(OnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                startSearch()
                return@OnEditorActionListener true
            }
            false
        })
        binding.btnSearch.setOnClickListener { startSearch() }
    }

    private fun closeKeyboard() {
        val imm =  getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(binding.et.windowToken, 0)
    }

    private fun startSearch() {
        AdManager.showTopOn(this@SearchActivity){
            closeKeyboard()
            binding.searchPb.visibility = View.VISIBLE
            val string: String = binding.et.text.toString()
            if (string.isNotEmpty()) {
                val search = ObectBoxManager.search(string)
                if (search.size > 0) {
                    showEmpty(false)
                    adapterWallapper.setDataInfo(search)
                    binding.searchPb.visibility = View.GONE
                } else {
                    binding.searchPb.visibility = View.GONE
                    showEmpty(true)
                }

            } else {
                binding.searchPb.visibility = View.GONE
                Toast.makeText(
                    this@SearchActivity,
                    getString(R.string.please_input_keyword),
                    Toast.LENGTH_SHORT
                ).show()
            }
        }

    }

    private fun showEmpty(showEmpty: Boolean) {
        if (showEmpty) {
            binding.emptyLayout.visibility = View.VISIBLE
            binding.resultRecycler.visibility = View.GONE
        } else {
            binding.emptyLayout.visibility = View.GONE
            binding.resultRecycler.visibility = View.VISIBLE
        }
    }

    override fun onItemClickAction(info: MyData?) {
        val intent = Intent(this, WallpaperActivity::class.java)
        intent.putExtra(ComUtils.key_info, info)
        startActivity(intent)
    }
}